void trigger_int() {

  //we store at what time we had a trigger
  trigger_time = micros();

  //the very first time we get a clock we reset this bit
  if (waiting_for_clock) {
    waiting_for_clock = 0;
    LEDs.setBrightness(40);
  }

  //clock going up
  if (!digitalRead(TRIG)) {
    //outputs for the divider function
    for (int i = 0; i < 8; i++) {
      //divider function
      if (toggle_divide[i]) {
        if (clock_counter % ratios[i] == 0) {
          FastWrite(i, HIGH);
          outs_micros[i] = 0;
          time_turned_on[i] = micros();
          out_state[i] = 1;
          LEDs.setPixelColor(i + 2, blue);
          show_leds = 1;
        }
      }

      //multiplier function
      if (!toggle_divide[i]) {
        FastWrite(i, HIGH);
        outs_micros[i] = 0;
        out_state[i] = 1;
        LEDs.setPixelColor(i + 2, green);
        show_leds = 1;
      }
    }

    LEDs.setPixelColor(0, 120, 50, 50);
    show_leds = 1;

    clock_counter++;

    if (clock_counter == 64) {
      clock_counter = 0;
    }

    trigger_on_time = trigger_time;
    period = trigger_on_time - previous_trigger_on_time;
    previous_trigger_on_time = trigger_on_time;
  }

  //clock going down
  if (digitalRead(TRIG)) {
    trigger_off_time = trigger_time;
    LEDs.setPixelColor(0, 0, 0, 0);
    show_leds = 1;
    clock_length = trigger_off_time - trigger_on_time;
  }
}

